<template>
    <div>
        <el-card class="!border-none mb-4" shadow="never">
            <el-form class="mb-[-16px]" :model="queryParams" inline>
                <el-form-item label="试题题干" prop="title">
                    <el-input
                        class="w-[280px]"
                        v-model="queryParams.title"
                        clearable
                        placeholder="请输入试题题干"
                    />
                </el-form-item>
                <el-form-item label="显示状态" prop="is_show">
                    <el-select
                        class="w-[280px]"
                        v-model="queryParams.is_show"
                        clearable
                        placeholder="请选择显示状态"
                    >
                        <el-option label="全部" value=""></el-option>
                        <el-option
                            v-for="(item, index) in dictData.show_status"
                            :key="index"
                            :label="item.name"
                            :value="item.value"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="收费状态" prop="is_free">
                    <el-select
                        class="w-[280px]"
                        v-model="queryParams.is_free"
                        clearable
                        placeholder="请选择收费状态"
                    >
                        <el-option label="全部" value=""></el-option>
                        <el-option
                            v-for="(item, index) in dictData.free_status"
                            :key="index"
                            :label="item.name"
                            :value="item.value"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="试卷分类" prop="category_uid">
                    <el-cascader
                        v-model="queryParams.category_uid"
                        :options="optionsData.category"
                        :props="props"
                        @change="handleChange"
                    />
                </el-form-item>
                <el-form-item label="试题难度" prop="level">
                    <el-select
                        class="w-[280px]"
                        v-model="queryParams.level"
                        clearable
                        placeholder="请选择试题难度"
                    >
                        <el-option label="全部" value=""></el-option>
                        <el-option
                            v-for="(item, index) in dictData.exam_level"
                            :key="index"
                            :label="item.name"
                            :value="item.value"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button type="primary" @click="resetPage">查询</el-button>
                    <el-button @click="resetParams">重置</el-button>
                </el-form-item>
            </el-form>
        </el-card>
        <el-card class="!border-none" v-loading="pager.loading" shadow="never">
            <div style="display: flex">
                <router-link
                    v-perms="['exam.examReading/add']"
                    :to="{
                        path: getRoutePath('exam.examReading/add:edit')
                    }"
                >
                    <el-button type="primary" class="mb-4">
                        <template #icon>
                            <icon name="el-icon-Plus" />
                        </template>
                        创建
                    </el-button>
                </router-link>
                <el-button
                    style="margin-left: 10px"
                    v-perms="['exam.examReading/delete']"
                    :disabled="!selectData.length"
                    @click="handleDelete(selectData)"
                >
                    删除
                </el-button>
            </div>
            <div class="mt-4">
                <el-table :data="pager.lists" @selection-change="handleSelectionChange"  style="width: 100%;" :cell-style="{'text-align':'left'}" :header-cell-style="{'text-align':'left'}">
                    <el-table-column type="selection" width="55" />
                    <el-table-column label="试卷分类" prop="category.title" />
                    <el-table-column label="试题题干" prop="title" min-width='200' />
                    <el-table-column label="显示状态" prop="is_show">
                        <template #default="{ row }">
                            <dict-value :options="dictData.show_status" :value="row.is_show" />
                        </template>
                    </el-table-column>
                    <el-table-column label="显示权重" prop="sort" show-overflow-tooltip />
                    <el-table-column label="收费状态" prop="is_free">
                        <template #default="{ row }">
                            <dict-value :options="dictData.free_status" :value="row.is_free" />
                        </template>
                    </el-table-column>
                    <el-table-column label="提交人数" prop="submit" show-overflow-tooltip />
                    <el-table-column label="收藏人数" prop="collect" show-overflow-tooltip />
                    <el-table-column label="试题积分" prop="score" show-overflow-tooltip />
                    <el-table-column label="试题难度" prop="level">
                        <template #default="{ row }">
                            <dict-value :options="dictData.exam_level" :value="row.level" />
                        </template>
                    </el-table-column>
                    <el-table-column label="操作" width="120" fixed="right">
                        <template #default="{ row }">
                            <el-button
                                v-perms="['exam.examReading/edit']"
                                type="primary"
                                link
                            >
                                <router-link
                                    :to="{
                                        path: getRoutePath('exam.examReading/add:edit'),
                                        query: {
                                            id: row.id
                                        }
                                    }"
                                >
                                    编辑
                                </router-link>
                            </el-button>
                            <el-button
                                v-perms="['exam.examReading/delete']"
                                type="danger"
                                link
                                @click="handleDelete(row.id)"
                            >
                                删除
                            </el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex mt-4 justify-end">
                <pagination v-model="pager" @change="getLists" />
            </div>
        </el-card>
    </div>
</template>

<script lang="ts" setup name="examReadingLists">
import { usePaging } from '@/hooks/usePaging'
import { useDictData, useDictOptions } from '@/hooks/useDictOptions'
import { apiExamReadingLists, apiExamReadingDelete } from '@/api/exam_reading'
import { apiExamCategoryTree } from '@/api/exam_category'
import { getRoutePath } from '@/router'
import feedback from '@/utils/feedback'

// 查询条件
const queryParams = reactive({
    title: '',
    is_show: '',
    is_free: '',
    category_uid: '',
    level: ''
})

// 选中数据
const selectData = ref<any[]>([])

// 表格选择后回调事件
const handleSelectionChange = (val: any[]) => {
    selectData.value = val.map(({ id }) => id)
}

const { optionsData } = useDictOptions<{
    category: any[]
}>({
    category: {
        api: apiExamCategoryTree
    }
})

// 试卷分类选择
const handleChange = (value) => {
    queryParams.category_uid = value[1]
}

// 获取字典数据
const { dictData } = useDictData('show_status,free_status,exam_level')

// 分页相关
const { pager, getLists, resetParams, resetPage } = usePaging({
    fetchFun: apiExamReadingLists,
    params: queryParams
})


// 删除
const handleDelete = async (id: number | any[]) => {
    await feedback.confirm('确定要删除？')
    await apiExamReadingDelete({ id })
    getLists()
}

getLists()
</script>
